#include <stdio.h>
#include <math.h>

#define M 24
#define N 2670177
#define C ( N * 2.0 * L_PI * pow(0.5, M) )

#define L_PI ((double)3.1415926535897932384626433832795028841971693993751058209749445923078164062862089986280348253421170679821480865132823066470938446095505822317253594081284811174502841027019385211055596446229489549303819L)

float x_sincos(float x, int flag_cos) {
	//{jx * N / 2^M̏oƁB
	//2΂|Ă0`2΂̊pxB
	
	uint ix, sx, ex, mx;
	float y;
	
	int flag_neg = 0;
	if (x < 0) {
		x = -x;
		if (!flag_cos) flag_neg = 1;
	}
	
	if (x/2 < 2 * L_PI) {
		y = x/2;
		goto RET;
	}
	
	ix = *(uint *)&x;
	ex = ix >> 23 & 0xFFUL;
	mx = ix & 0x7FFFFFUL | 1 << 23;
	
	if (x == 0. || ex >= 128 + 24 + 23)		//傫2΂̔{ƌȂ
		return flag_cos ? 1.0 : 0.0;
	
	uint mx_l, mx_h, n_l, n_h;
	
	mx_l = mx & 0x7FFFUL;
	mx_h = mx >> 15;
	n_l  = N  & 0x7FFFUL;
	n_h  = N  >> 15;
	
	uint mul_ll, mul_lh, mul_hl, mul_hh;
	
	mul_ll = mx_l * n_l;
	mul_lh = mx_l * n_h;
	mul_hl = mx_h * n_l;
	mul_hh = mx_h * n_h;
	
	uint mul_tmp, mul_l, mul_h;
	
	mul_tmp = mul_ll + ((mul_lh + mul_hl & 0x7FFFUL) << 15);
	mul_l = mul_tmp & 0x3FFFFFFFUL;
	mul_h = mul_hh + (mul_lh + mul_hl >> 15) + (mul_tmp >> 30);
	
	//x * n̉oB
	//2^(-23) * 2^(ex - 128) * 2^(-M)|邩A
	//151 + M - exԖڂ23bito΂悢i͂j
	//1.****Ƃĕ\̂ŁA1Ăŏbit̎23bitoB
	
	#define P (151 + M - ex)
	int i;
	uint sy, ey, my;
	
	sy = sx;
	
	for (i = P - 1, ey = 127; i >= 0; i--, ey--)
		if (i >= 30 && i < 60 && mul_h & 1 << (i - 30)) {	//͏30bit̒n܂
			my = mul_h & (1 << i - 30) - 1;
			if (i - 30 >= 23)
				my >>= i - 53;		//ʂ܂ŋy΂Ȃ
			else {
				my <<= 53 - i;		//ʂ܂ŋy
				my |= mul_l >> i - 23;	// & (1 << 53 - i) - 1;
			}
			break;
		} else if (i < 30 && mul_l & 1 << i) {		//͉30bit̒n܂
			my = mul_l & (1 << i) - 1;
			if (i >= 23)
				my >>= i - 23;
			else
				my <<= 23 - i;
			break;
		}
	
	if (i < 0)		//ׂ0A܂2΂̔{Ƃ݂Ȃ
		return flag_cos ? 1.0 : 0.0;
	
	uint iy;
	
	iy = ey << 23 | my;
	
	y = *(float *)&iy;
	
	y /= 2;
	y *= 2 * L_PI;
RET:
	if (L_PI < y) {
		y -= L_PI;
		flag_neg = !flag_neg;
	}
	if (L_PI/2 < y) {
		y = L_PI - y;
		if (flag_cos) flag_neg = !flag_neg;
	}
	if (L_PI/4 < y) {
		y = L_PI/2 - y;
		flag_cos = !flag_cos;
	}
	
	float x1, x2, x3, x4, x5, x6, x7, x8, x9;

	x1 = y;
	x2 = x1 * x1;
	x3 = x1 * x2;
	x4 = x2 * x2;
	x5 = x2 * x3;
	x6 = x3 * x3;
	x7 = x3 * x4;
	x8 = x4 * x4;
	x9 = x4 * x5;
	
	float ret;
	
	if (flag_cos) 
		ret = (flag_neg ? -1. : 1.) * (1. - x2 / 2. + x4 / 24. - x6 / 720. + x8 / 40320.);
	else
		ret = (flag_neg ? -1. : 1.) * (x1 - x3 / 6. + x5 / 120. - x7 / 5040. + x9 / 362880.);
	
	ret *= 2;
	
	return ret;
}

float randfloat(uint e) {
	
	uint f, xi;
	float xf;
	
	f = (rand() * rand()) & 0x7FFFFF;
	
	xi = e << 23 | f;
	xf = *(float *)&xi;
	
	return xf;
}

#define MAX(a, b) ((a) > (b) ? (a) : (b))
/*
int main(){
	uint e;
	
	srand(time(NULL));
	for (e = 100; e < 180; e++) {
		float f = randfloat(e);
		
		float s1 = x_sincos(f * 2, 0) / 2;
		float s2 = sin(C * f);
		float s3 = m_sin(f);
		float e1 = fabs(s2 - s1);
		float e2 = fabs(s2 * exp2(-18));
		float e3 = fabs(s2 - s3);
		
		printf("%d: %e: %e, %e, %e, %e, %e, %d, %d\n", e, f, s1, s2, s3, e1, e3, e1 < e2, e3 < e2);
	}
	//uint f = 0x456789AB;
	
	//x_sincos(*(float *)&f, 1);
}
*/