#include <stdio.h>
#include <math.h>

#define M 24
#define N 2670177
#define C ( N * 2.0 * L_PI * pow(0.5, M) )

#define L_PI ((double)3.1415926535897932384626433832795028841971693993751058209749445923078164062862089986280348253421170679821480865132823066470938446095505822317253594081284811174502841027019385211055596446229489549303819L)

#define DEBUG 0
#include<stdio.h>
#include<stdlib.h>
#include<float.h>

/*****************************************************************
  _Cu
  _dl Rev. 2.1 
*****************************************************************/

/*
History of Modification:

2004/10/26 created by xhl

2004/10/27 modified by xhl
fobOBxf_checǩ덷@ύXB
R[hShift_JIS / CRLF ɕύXB

2004/11/11 xhl
dl2.1ɕύXB

2004/11/13 xhl
_fpclassrB
*/



float frand(void)
{
  int i;
  int r = 0;
  for( i = 0; i < 32; i ++ )
    if( (rand () >> 8) & 1 )
      r |= 1 << i;
  return *(float *)&r;
}

#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif

typedef unsigned int xfloat;

/*****************************************************************
    tB[h`
*****************************************************************/

// IEEE 754 float
// etB[h(bit)
#define f_s_width  ( 1)
#define f_e_width  ( 8)
#define f_m_width  (23)

// xf_?_offset: etB[h̍ŉʃrbg̈ʒu(LSB = 0)
#define f_s_offset (xf_e_offset + xf_e_width)
#define f_e_offset (xf_m_offset + xf_m_width)
#define f_m_offset (0)

// etB[h̍őlB}XNɂgpłB
#define f_s_max ((1<< 1)-1)
#define f_e_max ((1<< 8)-1)
#define f_m_max ((1<<23)-1)

enum{
  f_s_plus  = 0,
  f_s_minus = 1
};

// xfloat
// etB[h(bit)
#define xf_s_width  ( 1)
#define xf_e_width  ( 8)
#define xf_m_width  (23)

// xf_?_offset: etB[h̍ŉʃrbg̈ʒu(LSB = 0)
#define xf_s_offset (xf_e_offset + xf_e_width)
#define xf_e_offset (xf_m_offset + xf_m_width)
#define xf_m_offset (0)

// etB[h̍őlB}XNɂgpłB
#define xf_s_max ((1<< 1)-1)
#define xf_e_max ((1<< 8)-1)
#define xf_m_max ((1<<23)-1)

enum{
  xf_s_plus  = 0,
  xf_s_minus = 1
};

/*****************************************************************
    (s, e, m)  IEEE 754 float, xfloat ̑ݕϊ
*****************************************************************/

int f_s( float f ) { return (int)( ( (*(unsigned int *)&f) >> f_s_offset) & f_s_max ); }
int f_e( float f ) { return (int)( ( (*(unsigned int *)&f) >> f_e_offset) & f_e_max ); }
int f_m( float f ) { return (int)( ( (*(unsigned int *)&f) >> f_m_offset) & f_m_max ); }
float f_sem( int s, int e, int m )
{
  int i = 
    ( (s & f_s_max) << f_s_offset ) | 
    ( (e & f_e_max) << f_e_offset ) | 
    ( (m & f_m_max) << f_m_offset );
  return *(float *)&i;
}

int xf_s( xfloat xf ) { return (int)( (xf >> xf_s_offset) & xf_s_max ); }
int xf_e( xfloat xf ) { return (int)( (xf >> xf_e_offset) & xf_e_max ); }
int xf_m( xfloat xf ) { return (int)( (xf >> xf_m_offset) & xf_m_max ); }
xfloat xf_sem( int s, int e, int m )
{
  return (xfloat)(
    ( (s & xf_s_max) << xf_s_offset ) | 
    ( (e & xf_e_max) << xf_e_offset ) | 
    ( (m & xf_m_max) << xf_m_offset )
  );
}

/*****************************************************************
    ʔ
*****************************************************************/
int f_isNaN( float f )
{
  // w == xf_e_max  0ȊO
  return f_e(f) == f_e_max && 
         f_m(f) != 0;
}
int f_isInf( float f )
{
  // w == xf_e_max  0
  return f_e(f) == f_e_max && 
         f_m(f) == 0;
}
int f_isPInf( float f )
{
  // Inf
  return f_isInf(f) && f_s(f) == f_s_plus;
}
int f_isMInf( float f )
{
  // Inf
  return f_isInf(f) && f_s(f) == f_s_minus;
}
int f_isZero( float f )
{
  // w == 0   == 0
  return f_e(f) == 0 && 
         f_m(f) == 0;
}
int f_isDenormal( float f )
{
  // w == 0   != 0
  return f_e(f) == 0 && 
         f_m(f) != 0;
}
int f_isNormal( float f )
{
  return 0 < f_e(f) && f_e(f) < f_e_max;
}

/*
// Rev. 2
int xf_isNaN( xfloat xf )
{
  // w == xf_e_max  ̍ŏʂ1
  return xf_e(xf) == xf_e_max && 
         (xf_m(xf) >> (xf_m_width-1)) != 0;
}
int xf_isInf( xfloat xf )
{
  // w == xf_e_max  ̍ŏʂ0
  return xf_e(xf) == xf_e_max && 
        (xf_m(xf) >> (xf_m_width-1)) == 0;
}
*/

int xf_isNaN( xfloat xf )
{
  // w == xf_e_max  ̍ŉʂ1
  return xf_e(xf) == xf_e_max && 
        (xf_m(xf) & 1) == 1;
}
int xf_isInf( xfloat xf )
{
  // w == xf_e_max  ̍ŉʂ0
  return xf_e(xf) == xf_e_max && 
        (xf_m(xf) & 1) == 0;
}

int xf_isPInf( xfloat xf )
{
  // Inf
  return xf_isInf(xf) && xf_s(xf) == xf_s_plus;
}
int xf_isMInf( xfloat xf )
{
  // Inf
  return xf_isInf(xf) && xf_s(xf) == xf_s_minus;
}
int xf_isZero( xfloat xf )
{
  // w == 0
  return xf_e(xf) == 0;
}
int xf_isNormal( xfloat xf )
{
  return 0 < xf_e(xf) && xf_e(xf) < xf_e_max;
}

/*****************************************************************
    W``EW
*****************************************************************/

#define f_NaN_canonical   (f_sem(f_s_plus,  f_e_max, f_m_max))
#define f_PInf_canonical  (f_sem(f_s_plus,  f_e_max, 0      ))
#define f_MInf_canonical  (f_sem(f_s_minus, f_e_max, 0      ))
#define f_Zero_canonical  (f_sem(f_s_plus,  0,       0      ))

#define f_MNormal_max     (f_sem(f_s_minus,  f_e_max - 1, f_m_max))
#define f_MNormal_min     (f_sem(f_s_minus,  1,           0      ))
#define f_PNormal_min     (f_sem(f_s_plus,   1,           0      ))
#define f_PNormal_max     (f_sem(f_s_plus,   f_e_max - 1, f_m_max))

#define epsilon           ( pow( 2.0, -126 ) )
#define f_d_MInf          ( ((double)f_sem(f_s_minus,  f_e_max - 1,       0)) * 2.0 )
#define f_d_PInf          ( ((double)f_sem(f_s_plus,   f_e_max - 1,       0)) * 2.0 )


#define xf_NaN_canonical  (xf_sem(xf_s_plus,  xf_e_max, xf_m_max))
#define xf_PInf_canonical (xf_sem(xf_s_plus,  xf_e_max, 0       ))
#define xf_MInf_canonical (xf_sem(xf_s_minus, xf_e_max, 0       ))
#define xf_Zero_canonical (xf_sem(xf_s_plus,  0,        0       ))

#define xf_MNormal_max    (xf_sem(xf_s_minus,  xf_e_max - 1, xf_m_max))
#define xf_MNormal_min    (xf_sem(xf_s_minus,  1,            0       ))
#define xf_PNormal_min    (xf_sem(xf_s_plus,   1,            0       ))
#define xf_PNormal_max    (xf_sem(xf_s_plus,   xf_e_max - 1, xf_m_max))

// rbgp^[𓝈ꂵA񐳋K0ɂ
float f_canonical( float f )
{
  if     ( f_isNaN ( f ) ) return f_NaN_canonical;
  else if( f_isPInf( f ) ) return f_PInf_canonical;
  else if( f_isMInf( f ) ) return f_MInf_canonical;
  else if( f_isZero( f ) ) return f_Zero_canonical;
  else if( f_isDenormal( f ) ) return f_Zero_canonical;
  else                       return f; // K͂̂܂܂OK
}

xfloat xf_canonical( xfloat xf )
{
  if     ( xf_isNaN ( xf ) ) return xf_NaN_canonical;
  else if( xf_isPInf( xf ) ) return xf_PInf_canonical;
  else if( xf_isMInf( xf ) ) return xf_MInf_canonical;
  else if( xf_isZero( xf ) ) return xf_Zero_canonical;
  else                       return xf; // K͂̂܂܂OK
}

/*****************************************************************
    IEEE 754 float Ƃ̑ݕϊ
*****************************************************************/

xfloat xf_ieee2xf( float f )
{
  if     ( f_isNaN ( f ) ) return xf_NaN_canonical;
  else if( f_isPInf( f ) ) return xf_PInf_canonical;
  else if( f_isMInf( f ) ) return xf_MInf_canonical;
  else if( f_isZero( f ) ) return xf_Zero_canonical;
  else if( f_isDenormal( f ) ) return xf_Zero_canonical;
  else                       return *(xfloat *)&f; // K͂̂܂܂OK
}

float xf_xf2ieee( xfloat xf )
{
  if     ( xf_isNaN ( xf ) ) return f_NaN_canonical;
  else if( xf_isPInf( xf ) ) return f_PInf_canonical;
  else if( xf_isMInf( xf ) ) return f_MInf_canonical;
  else if( xf_isZero( xf ) ) return f_Zero_canonical;
  else                       return *(float *)&xf; // K͂̂܂܂OK
}

float xf_sincos2( float x, int flag_sin )
{
	x = f_canonical( x );
	if( x == 0 || x >= (float)pow(2.0, 150 - 127 + M) ){
		if( flag_sin )
			return 0.0F;
		else
			return 1.0F;
	}

#define float double
	float nx = (float)(N * x / pow(2, M));
	if( DEBUG )
		printf( "n*x = %.30f / %08x\n", nx, *(int *)&nx );
/* n * x/2^m̏ o */
	xfloat f = *(xfloat *)&x;
	int sx, ex, mx;
	sx = xf_s( f );
	ex = xf_e( f );
	mx = xf_m( f );

/*
    if( ex < 24 ){
		if( flag_sin )
			return x;
		else
			return 1.0F;
	}
*/

	mx |= (1<<23);
	int m_hh, m_hl, m_lh, m_ll;
	m_hh = (mx >> 15)         * (N >> 15);
	m_hl = (mx >> 15)         * (N & ((1<<15)-1));
	m_lh = (mx & ((1<<15)-1)) * (N >> 15);
	m_ll = (mx & ((1<<15)-1)) * (N & ((1<<15)-1));
	int m_h, m_l;
	m_l = m_ll + ( ( (m_hl + m_lh) & ((1<<15)-1) )  << 15);
	m_h = m_hh + ((m_hl + m_lh) >> 15) + (m_l >> 30);
	m_l &= (1<<30) - 1;
	/* ܂ł n*x̉oB30bitr_l, ʂr_h */
	/*  2^(ex - 127) * 2^-23 * 2^-m = 2^(ex-150-m) = 0.5^(150+m-ex)
	܂150-exrbgEVtg
	ł͏23bit̂ŁAʂ(150+m-ex)rbgB
	 */
	int i, r_e, flag;
	for( i = 150+M-ex-1, r_e = 126; i >= 0; i --, r_e -- ){
		if( i >= 30 && i < 60 )
			flag = m_h >> (i-30);
		else if( i < 30 )
			flag = m_l >> i;
		else
			flag = 0;
		if( flag & 1 )
			break;
	}
	float if2;
	int if2_h, if2_l, if2_s, if2_e;
	if2_s = sx;
	if( i < 0 ){
		if( flag_sin )
			return 0.0F;
		else
			return 1.0F;
	}
    else if( r_e < /*24*/ 127 - 24 ){ /* if2Ō(w̉𓥂݉z) */
		if( flag_sin )
			return x;
		else
			return 1.0F;
	}
	else{
		int j, r_m = 0, round_bit;
		if2_h = if2_l = 0;
		for( i --, j = 0; j < 23; j ++ ){
			if( i - j >= 30 ){
				if( (m_h >> (i-j-30)) & 1 )
					r_m |= (1<<(22-j));
			}
			else if( i - j >= 0 ){
				if( (m_l >> (i-j)) & 1 )
					r_m |= (1<<(22-j));
			}
		}
		round_bit = 0;
		if( i - j >= 30 ){
			if( (m_h >> (i-j-30)) & 1 )
				round_bit = 1;
		}
		else if( i - j >= 0 ){
			if( (m_l >> (i-j)) & 1 )
				round_bit = 1;
		}

		for( j = 0; j < 30; j ++ ){
			if( i - j >= 30 ){
				if( (m_h >> (i-j-30)) & 1 )
					if2_h |= (1<<(29-j));
			}
			else if( i - j >= 0 ){
				if( (m_l >> (i-j)) & 1 )
					if2_h |= (1<<(29-j));
			}
		}
		for( j = 30; j < 60; j ++ ){
			if( i - j >= 30 ){
				if( (m_h >> (i-j-30)) & 1 )
					if2_l |= (1<<(29-(j-30)));
			}
			else if( i - j >= 0 ){
				if( (m_l >> (i-j)) & 1 )
					if2_l |= (1<<(29-(j-30)));
			}
		}

//		r_m += round_bit;
		if( r_m >> 23 ){
			r_e ++;
			r_m = 0;
		}
		if2_e = r_e;
		if2 = xf_xf2ieee( xf_sem( sx, r_e, r_m ) );

		int *ip = (int *)&if2;
		ip[0] = (if2_l >> 8) | (if2_h & ((1<<10)-1)) << 22;
	}
	if( DEBUG ){
		printf( "%d %d %d\n", sx, r_e, 0 );
		printf( "if2 = %.30lf / %08x\n", if2, *(int *)&if2 );
	}

	int flag_neg = 0;

	if( if2 < 0 ){
		if( flag_sin )
			flag_neg = !flag_neg;
		if2 = -if2;
	}
	/*  0 ` 1 */
	if( if2 >= 0.5 ){
		if( flag_sin )
			flag_neg = !flag_neg;
		if2 = 1.0 - if2;
	}
	/*  0 ` 0.5 */

	if( 0.125F <= if2 && if2 < 0.25F ){
		flag_sin = !flag_sin;
		if2 = 0.25F - if2;
	}
	else if( 0.25F <= if2 && if2 < 0.375F ){
		if( !flag_sin )
			flag_neg = !flag_neg;
		flag_sin = !flag_sin;
		if2 = if2 - 0.25F;
	}
	else if( 0.375F <= if2 ){
		if( !flag_sin )
			flag_neg = !flag_neg;
		if2 = 0.5F - if2;
	}

	if2 = (float)(if2 * 2.0 * M_PI);

	if( DEBUG )
		printf( "if2 = %.30f / %08x\n", if2, *(int *)&if2 );

	float r;
	float x2, x3, x4, x5, x6, x7, x8, x9;
	x2 = if2 * if2;
	x3 = x2 * if2;
	x4 = x2 * x2;
	x5 = x3 * x2;
	x6 = x3 * x3;
	x7 = x4 * x3;
	x8 = x4 * x4;
	x9 = x5 * x4;
	
	if( DEBUG ){
		printf( "if2 = %.30f / %08x\n", if2, *(int *)&if2 );
		printf( "x2  = %.30f / %08x\n", x2, *(int *)&x2 );
		printf( "x3  = %.30f / %08x\n", x3, *(int *)&x3 );
		printf( "x4  = %.30f / %08x\n", x4, *(int *)&x4 );
		printf( "x5  = %.30f / %08x\n", x5, *(int *)&x5 );
		printf( "x6  = %.30f / %08x\n", x6, *(int *)&x6 );
		printf( "x7  = %.30f / %08x\n", x7, *(int *)&x7 );
		printf( "x8  = %.30f / %08x\n", x8, *(int *)&x8 );
		printf( "x9  = %.30f / %08x\n", x9, *(int *)&x9 );
	}
	if( flag_sin )
		r = if2  - (x3/6.0F - (x5/120.0F - (x7/5040.0F - x9/(5040.0F*72.0F))));
	else
		r = 1.0F - (x2/2.0F - (x4/ 24.0F - (x6/ 720.0F - x8/(5040.0F* 8.0F))));

	if( flag_neg )
		return -r;
	else
		return r;
}
int fr2ir( float x )
{
	return *(int *)&x;
}

float xf_sincos( float x, int flag_sin )
{
	//x = f_canonical( x );

	int f  = fr2ir( x );
	int sx = (x < 0);
	int ex = (f >> 23) & ((1<<8)-1);
	int mx = (f & ((1<<23)-1)) | (1<<23);
/*
	sx = xf_s( f );
	ex = xf_e( f );
	mx = xf_m( f );
*/

	if( ex == 0 || ex >= 150 + M ){
//	if( x == 0 || x >= (float)pow(2.0, 150 - 127 + M) ){
		if( flag_sin )
			return 0.0F;
		else
			return 1.0F;
	}

    if( ex < 127 - 24 ){
		if( flag_sin )
			return x;
		else
			return 1.0F;
	}

	if( DEBUG ){
		float nx = (float)(N * x / pow(2, M));
		printf( "n*x = %.30f / %08x\n", nx, *(int *)&nx );
	}

/* n * x/2^m̏ o */

	int mx_h = mx >> 15;
	int mx_l = mx & ((1<<15)-1);
	int n_h  = N  >> 15;
	int n_l  = N  & ((1<<15)-1);

	int m_hh = mx_h * n_h;
	int m_hl = mx_h * n_l;
	int m_lh = mx_l * n_h;
	int m_ll = mx_l * n_l;
	int m_lt = m_ll + ( ( (m_hl + m_lh) & ((1<<15)-1) )  << 15);
	int m_h  = m_hh + ( (m_hl + m_lh) >> 15) + (m_lt >> 30);
	int m_l  = m_lt & ((1<<30)-1);
	/* ܂ł n*x̉oB30bitr_l, ʂr_h */
	/*  2^(ex - 127) * 2^-23 * 2^-m = 2^(ex-150-m) = 0.5^(150+m-ex)
	܂150-exrbgEVtg
	ł͏23bit̂ŁAʂ(150+m-ex)rbgB
	 */
	if( DEBUG ){
		printf( "%x %x\n", m_h, m_l );
		printf( "%d %d\n", ex, 151-ex );
		printf( "%.30lf\n", (m_h + m_l / pow(2, 30)) / pow(2, 30) );
	}

	int if2_h, if2_l;
	int shft = 60 - (151-ex) - M + 1;
	if( shft < 0 ){
		shft = -shft;
		if( shft >= 30 )
			if2_h = 0;
		else
			if2_h = m_h >> shft;
		if( shft >= 60 )
			if2_l = 0;
		else if( shft >= 30 )
			if2_l = m_h >> (shft-30);
		else
			if2_l = (m_l >> shft) | ((m_h & ((1<<shft)-1)) << (30-shft));
	}
	else{
		if( shft >= 60 )
			if2_h = 0;
		else if( shft >= 30 )
			if2_h = (m_l << (shft-30)) & ((1<<30)-1);
		else
			if2_h = ((m_h << shft) & ((1<<30)-1)) | (m_l >> (30-shft));
		if( shft >= 30 )
			if2_l = 0;
		else
			if2_l = (m_l << shft) & ((1<<30)-1);
	}

/*
    if( if2_h == 0 && (if2_l >> 15) == 0 ){
		if( flag_sin )
			return x;
		else
			return 1.0F;
	}
*/

	if( DEBUG ){
		printf( "%x %x\n", if2_h, if2_l );
		printf( "%.30lf\n", (if2_h + if2_l / pow(2, 30)) / pow(2, 30) );
	}

	int flag_neg = 0;

	if( sx ){	//	
		if( flag_sin )
			flag_neg = !flag_neg;
	}
	/*  0 ` 1 */

//	29: 0.5
//	28: 0.25
//	27: 0.125

	if( if2_h >> 29 ){	// if2 >= 0.5
		if( flag_sin )
			flag_neg = !flag_neg;
		// if2 = 1.0F - if2;
		if2_h = ((~ if2_h) & ((1<<29)-1)) + (if2_l == 0 ? 1 : 0);
		if2_l = ((~if2_l) + 1) & ((1<<30)-1);
	}
	/*  0 ` 0.5 */

	if( (if2_h >> 28) & 1 ){
		if( (if2_h >> 27) & 1 ){
			//	0.375 <= if2 < 0.5
			if( !flag_sin )
				flag_neg = !flag_neg;
			// if2 = 0.5F - if2;
			if2_h = ((~ if2_h) & ((1<<27)-1)) + (if2_l == 0 ? 1 : 0);
			if2_l = ((~if2_l) + 1) & ((1<<30)-1);
		}
		else{
			// 0.25 <= if2 < 0.375
			if( !flag_sin )
				flag_neg = !flag_neg;
			flag_sin = !flag_sin;
			// if2 = if2 - 0.25F;
			if2_h = (if2_h) & ((1<<27)-1);
		}
	}
	else{
		if( (if2_h >> 27) & 1 ){
			//	0.125 <= if2 < 0.25
			flag_sin = !flag_sin;
			// if2 = 0.25F - if2;
			if2_h = ((~ if2_h) & ((1<<27)-1)) + (if2_l == 0 ? 1 : 0);
			if2_l = ((~if2_l) + 1) & ((1<<30)-1);
		}
	}

	if( (if2_h >> 29) & 1 ){
		//	0.5
		if( flag_sin )
			return 0.0F;
		else
			if( flag_neg )
				return 1.0F;
			else
				return -1.0F;
	}
	if( (if2_h >> 28) & 1 ){
		//	0.25
		if( flag_sin )
			if( flag_neg )
				return -1.0F;
			else
				return 1.0F;
		else
			return 0.0F;
	}

	float if2_0 = (float)( if2_l & ((1<<20)-1) );
	float if2_1 = (float)( ((if2_h & ((1<<10)-1)) << 10) | (if2_l >> 20) );
	float if2_2 = (float)( if2_h >> 10 );
	float if2 = (if2_2 + (if2_1 + if2_0 * (float)pow(2, -20)) * (float)pow(2, -20)) * (float)pow(2, -19) * (float)M_PI;
//	float if2 = (float)(((double)if2_h + if2_l / pow(2,30)) / pow(2, 30)) * (float)2.0 * (float)M_PI;

	if( DEBUG )
		printf( "if2 = %.30f / %08x\n", if2, *(int *)&if2 );

	float r;
	float x2, x3, x4, x5, x6, x7, x8, x9;
	x2 = if2 * if2;
	x3 = x2 * if2;
	x4 = x2 * x2;
	x5 = x3 * x2;
	x6 = x3 * x3;
	x7 = x4 * x3;
	x8 = x4 * x4;
	x9 = x5 * x4;
	
	if( DEBUG ){
		printf( "if2 = %.30f / %08x\n", if2, *(int *)&if2 );
		printf( "x2  = %.30f / %08x\n", x2, *(int *)&x2 );
		printf( "x3  = %.30f / %08x\n", x3, *(int *)&x3 );
		printf( "x4  = %.30f / %08x\n", x4, *(int *)&x4 );
		printf( "x5  = %.30f / %08x\n", x5, *(int *)&x5 );
		printf( "x6  = %.30f / %08x\n", x6, *(int *)&x6 );
		printf( "x7  = %.30f / %08x\n", x7, *(int *)&x7 );
		printf( "x8  = %.30f / %08x\n", x8, *(int *)&x8 );
		printf( "x9  = %.30f / %08x\n", x9, *(int *)&x9 );
	}
	if( flag_sin )
		r = if2  - (x3*(1.0F/6.0F) - (x5*(1.0F/120.0F) - (x7*(1.0F/5040.0F) - x9*(1.0F/(5040.0F*72.0F)))));
	else
		r = 1.0F - (x2*(1.0F/2.0F) - (x4*(1.0F/ 24.0F) - (x6*(1.0F/ 720.0F) - x8*(1.0F/(5040.0F* 8.0F)))));

	if( flag_neg )
		return -r;
	else
		return r;
}


float sub_2pi(float x){
  unsigned long l;
  short e;
  
  l = *(unsigned long *)&x;
  e = l >> 23 & 0xFF;
  e -= 127;
  if(e < 2)
    return x;
  else
    return x - L_PI * exp2(e - 1);
}

float sincos3(float x, int flag) {
	int s = 0;
	float y, z;
	
	y = z = x;
	
	do {
		y = z;
		z = sub_2pi(z);
		if (z < 0) {
			z = -z;
			if (!flag) s = !s;
		}
	} while(y != z);	
	
	if (y > L_PI) {
		y -= L_PI;
		s = !s;
	}
	if (y > L_PI / 2) {
		y = L_PI - y;
		if (flag) s = !s;
	}
	if (y > L_PI / 4) {
		y = L_PI / 2 - y;
		flag = !flag;
	}
	
	float x1, x2, x3, x4, x5, x6, x7, x8, x9;
	
	x1 = y;
	x2 = x1 * x1;
	x3 = x1 * x2;
	x4 = x2 * x2;
	x5 = x2 * x3;
	x6 = x3 * x3;
	x7 = x3 * x4;
	x8 = x4 * x4;
	x9 = x4 * x5;
	
	if (flag)
		return (s ? -1. : 1.) * (1. - x2 / 2. + x4 / 24. - x6 / 720. + x8 / 40320.);
	else
		return (s ? -1. : 1.) * (x1 - x3 / 6. + x5 / 120. - x7 / 5040. + x9 / 362880.);
}

float x_sincos(float x, int flag_cos) {
	//{jx * n / 2^m̏oƁB
	//2΂|Ă0`2΂̊pxB
	
	uint ix, sx, ex, mx;
	float y;
	
	int flag_neg = 0;
	if (x < 0) {
		x = -x;
		if (!flag_cos) flag_neg = 1;
	}
	
	if (x/2 < 2 * L_PI) {
		y = x/2;
		goto RET;
	}
	
	ix = *(uint *)&x;
	ex = ix >> 23 & 0xFFUL;
	mx = ix & 0x7FFFFFUL | 1 << 23;
	
	if (x == 0. || ex >= 128 + 24 + 23)		//傫2΂̔{ƌȂ
		return flag_cos ? 1.0 : 0.0;
	
	uint mx_l, mx_h, n_l, n_h;
	
	mx_l = mx & 0x7FFFUL;
	mx_h = mx >> 15;
	n_l  = N  & 0x7FFFUL;
	n_h  = N  >> 15;
	
	uint mul_ll, mul_lh, mul_hl, mul_hh;
	
	mul_ll = mx_l * n_l;
	mul_lh = mx_l * n_h;
	mul_hl = mx_h * n_l;
	mul_hh = mx_h * n_h;
	
	uint mul_tmp, mul_l, mul_h;
	
	mul_tmp = mul_ll + ((mul_lh + mul_hl & 0x7FFFUL) << 15);
	mul_l = mul_tmp & 0x3FFFFFFFUL;
	mul_h = mul_hh + (mul_lh + mul_hl >> 15) + (mul_tmp >> 30);
	
	//x * n̉oB
	//2^(-23) * 2^(ex - 128) * 2^(-m)|邩A
	//151 + m - exԖڂ23bito΂悢i͂j
	//1.****Ƃĕ\̂ŁA1Ăŏbit̎23bitoB
	
	#define P (151 + M - ex)
	int i;
	uint sy, ey, my;
	
	sy = sx;
	
	for (i = P - 1, ey = 127; i >= 0; i--, ey--)
		if (i >= 30 && i < 60 && mul_h & 1 << (i - 30)) {	//͏30bit̒n܂
			my = mul_h & (1 << i - 30) - 1;
			if (i - 30 >= 23)
				my >>= i - 53;		//ʂ܂ŋy΂Ȃ
			else {
				my <<= 53 - i;		//ʂ܂ŋy
				my |= mul_l >> i - 23;	// & (1 << 53 - i) - 1;
			}
			break;
		} else if (i < 30 && mul_l & 1 << i) {		//͉30bit̒n܂
			my = mul_l & (1 << i) - 1;
			if (i >= 23)
				my >>= i - 23;
			else
				my <<= 23 - i;
			break;
		}
	
	if (i < 0)		//ׂ0A܂2΂̔{Ƃ݂Ȃ
		return flag_cos ? 1.0 : 0.0;
	
	uint iy;
	
	iy = ey << 23 | my;
	
	y = *(float *)&iy;
	
	y /= 2;
	y *= 2 * L_PI;
RET:
	if (L_PI < y) {
		y -= L_PI;
		flag_neg = !flag_neg;
	}
	if (L_PI/2 < y) {
		y = L_PI - y;
		if (flag_cos) flag_neg = !flag_neg;
	}
	if (L_PI/4 < y) {
		y = L_PI/2 - y;
		flag_cos = !flag_cos;
	}
	
	float x1, x2, x3, x4, x5, x6, x7, x8, x9;

	x1 = y;
	x2 = x1 * x1;
	x3 = x1 * x2;
	x4 = x2 * x2;
	x5 = x2 * x3;
	x6 = x3 * x3;
	x7 = x3 * x4;
	x8 = x4 * x4;
	x9 = x4 * x5;
	
	float ret;
	
	if (flag_cos)
		ret = (flag_neg ? -1. : 1.) * (1. - x2 / 2. + x4 / 24. - x6 / 720. + x8 / 40320.);
	else
		ret = (flag_neg ? -1. : 1.) * (x1 - x3 / 6. + x5 / 120. - x7 / 5040. + x9 / 362880.);
	
	ret *= 2;
	return ret;
}
float randfloat(uint e) {
	
	uint f, xi;
	float xf;
	
	f = (rand() * rand()) & 0x7FFFFF;
	
	xi = e << 23 | f;
	xf = *(float *)&xi;
	
	return xf;
}

#define MAX(x, y) ((x) > (y) ? (x) : (y))

int main(){
	uint e;
	float f;
	float psin, tsin;
	float err;
	float err_max = 0, err_min = 0;
	
	srand(time(NULL));
loop:
	e = rand() % 174;
	f = randfloat(e);
	
	psin = sincos3(f, 0);	
	tsin = sin(C * f);
	err = (psin - tsin) / MAX(fabs(tsin * exp2(-18)), exp2(-126)) * 100.;
	
	if (err > err_max) {
		err_max = err;
		printf("err_max = %.10e%%, f = %13e\n", err_max, f);
	} else if (err < err_min) {
		err_min = err;
		printf("err_min = %.10e%%, f = %13e\n", err_min, f);
	}
	
	goto loop;
}
